# EN_sqrt_DW_coq

Formalisation  in Coq of double double square-root and euclidean norm


Formalisation in Coq of the paper "Accurate calculation of Euclidean Norms using Double-word arithmetic" by V. Lefèvre, N. Louvet, J-M.  Muller, J. Picot and  L. Rideau. 




# building
##nix

If `nix` is installed on your machine, you simply need to execute the following command
<code>
nix-shell 
make
</code>

##opam
If opam is installed on your machine, you simply need to execute the following command
<code>
opam switch create sandbox ocaml-base-compiler.4.09.1
opam repo add coq-released https://coq.inria.fr/opam/released
opam install --inplace-build ./coq-double-square-root.opam
eval $(opam env)
</code>
Compilation can take a few tens of minutes.


##use

Then you will be able to use the development in Coq by a session of the
following form:

<code>
 coqtop.opt -R . Double
Require Import Reals  Psatz.
From Flocq Require Import Core Relative Sterbenz Operations Mult_error  Plus_error.
Require Import Bayleyaux square_root_flx.
(* Correctness of the algorithms for square root  in the paper *)
Check SQRTDW_bounds.

</code>
